/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Diff of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.37 Revision 1.133
1# Copyright 1999-2003 Gentoo Technologies, Inc. 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.37 2004/02/21 07:19:29 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.133 2009/04/04 17:57:54 grobian Exp $
4
5# @ECLASS: flag-o-matic.eclass
6# @MAINTAINER:
7# toolchain@gentoo.org
8# @BLURB: common functions to manipulate and query toolchain flags
9# @DESCRIPTION:
10# This eclass contains a suite of functions to help developers sanely
11# and safely manage toolchain flags in their builds.
12
13inherit eutils toolchain-funcs multilib
14
15################ DEPRECATED functions ################
16# The following are still present to avoid breaking existing
17# code more than necessary; however they are deprecated. Please
18# use gcc-specs-* from toolchain-funcs.eclass instead, if you
19# need to know which hardened techs are active in the compiler.
20# See bug #100974
4# 21#
5# Author Bart Verwilst <verwilst@gentoo.org> 22# has_hardened
23# has_pie
24# has_pic
25# has_ssp_all
26# has_ssp
6 27
7ECLASS=flag-o-matic
8INHERITED="$INHERITED $ECLASS"
9 28
10#
11#### filter-flags <flags> ####
12# Remove particular flags from C[XX]FLAGS
13# Matches only complete flags
14#
15#### append-flags <flags> ####
16# Add extra flags to your current C[XX]FLAGS
17#
18#### replace-flags <orig.flag> <new.flag> ###
19# Replace a flag by another one
20#
21#### replace-cpu-flags <new.cpu> <old.cpus> ###
22# Replace march/mcpu flags that specify <old.cpus>
23# with flags that specify <new.cpu>
24#
25#### is-flag <flag> ####
26# Returns "true" if flag is set in C[XX]FLAGS
27# Matches only complete a flag
28#
29#### strip-flags ####
30# Strip C[XX]FLAGS of everything except known
31# good options.
32#
33#### strip-unsupported-flags ####
34# Strip C[XX]FLAGS of any flags not supported by
35# installed version of gcc
36#
37#### get-flag <flag> ####
38# Find and echo the value for a particular flag
39#
40#### replace-sparc64-flags ####
41# Sets mcpu to v8 and uses the original value
42# as mtune if none specified.
43#
44#### filter-mfpmath <math types> ####
45# Remove specified math types from the fpmath specification
46# If the user has -mfpmath=sse,386, running `filter-mfpmath sse`
47# will leave the user with -mfpmath=386
48#
49#### append-ldflags ####
50# Add extra flags to your current LDFLAGS
51#
52#### etexec-flags ####
53# hooked function for hardened-gcc that appends
54# -yet_exec {C,CXX,LD}FLAGS when hardened-gcc is installed
55# and a package is filtering -fPIC,-fpic, -fPIE, -fpie
56#
57#### fstack-flags ####
58# hooked function for hardened-gcc that appends
59# -yno_propolice to {C,CXX,LD}FLAGS when hardened-gcc is installed
60# and a package is filtering -fstack-protector, -fstack-protector-all
61#
62
63# C[XX]FLAGS that we allow in strip-flags 29# {C,CXX,F,FC}FLAGS that we allow in strip-flags
30# Note: shell globs and character lists are allowed
64setup-allowed-flags() { 31setup-allowed-flags() {
65 export ALLOWED_FLAGS="-O -O1 -O2 -mcpu -march -mtune -fstack-protector -pipe -g" 32 if [[ -z ${ALLOWED_FLAGS} ]] ; then
66 case "${ARCH}" in 33 export ALLOWED_FLAGS="-pipe"
67 mips) ALLOWED_FLAGS="${ALLOWED_FLAGS} -mips1 -mips2 -mips3 -mips4 -mabi" ;; 34 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune"
68 amd64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 35 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all"
36 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking -fno-strict-overflow"
37 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time"
38 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+"
39 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-ident"
69 alpha) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 40 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -W* -w"
70 ia64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 41 fi
71 esac 42 # allow a bunch of flags that negate features / control ABI
43 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all \
44 -fno-strict-aliasing -fno-bounds-checking -fstrict-overflow"
45 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \
46 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \
47 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \
48 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
49 -mieee -mieee-with-inexact -mschedule \
50 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \
51 -mflat -mno-flat -mno-faster-structs -mfaster-structs \
52 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \
53 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias \
54 -msecure-plt -m*-toc -D* -U*"
55
56 # killing these two on OSX/Intel will disable SSE, resulting in failing
57 # compilations, as the headers expect SSE to be enabled (Apple knows what
58 # hardware they run on afterall, don't they?)
59 [[ ${CHOST} == i?86-apple-darwin* ]] \
60 && ALLOWED_FLAGS="${ALLOWED_FLAGS} -march=prescott -march=nocona"
72 61
73 # C[XX]FLAGS that we are think is ok, but needs testing 62 # {C,CXX,F,FC}FLAGS that we are think is ok, but needs testing
74 # NOTE: currently -Os have issues with gcc3 and K6* arch's 63 # NOTE: currently -Os have issues with gcc3 and K6* arch's
75 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks -fprefetch-loop-arrays" 64 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks"
76 return 0 65 return 0
77} 66}
78 67
68# inverted filters for hardened compiler. This is trying to unpick
69# the hardened compiler defaults.
70_filter-hardened() {
71 local f
72 for f in "$@" ; do
73 case "${f}" in
74 # Ideally we should only concern ourselves with PIE flags,
75 # not -fPIC or -fpic, but too many places filter -fPIC without
76 # thinking about -fPIE.
77 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
78 gcc-specs-pie || continue
79 is-flagq -nopie || append-flags -nopie;;
80 -fstack-protector)
81 gcc-specs-ssp || continue
82 is-flagq -fno-stack-protector || append-flags $(test-flags -fno-stack-protector);;
83 -fstack-protector-all)
84 gcc-specs-ssp-to-all || continue
85 is-flagq -fno-stack-protector-all || append-flags $(test-flags -fno-stack-protector-all);;
86 -fno-strict-overflow)
87 gcc-specs-nostrict || continue
88 is-flagq -fstrict-overflow || append-flags $(test-flags -fstrict-overflow);;
89 esac
90 done
91}
92
93# Remove occurrences of strings from variable given in $1
94# Strings removed are matched as globs, so for example
95# '-O*' would remove -O1, -O2 etc.
96_filter-var() {
97 local f x VAR VAL
98 declare -a new
99
100 VAR=$1
101 shift
102 eval VAL=\${${VAR}}
103 for f in ${VAL}; do
104 for x in "$@"; do
105 # Note this should work with globs like -O*
106 [[ ${f} == ${x} ]] && continue 2
107 done
108 eval new\[\${\#new\[@]}]=\${f}
109 done
110 eval export ${VAR}=\${new\[*]}
111}
112
113# @FUNCTION: filter-flags
114# @USAGE: <flags>
115# @DESCRIPTION:
116# Remove particular <flags> from {C,CPP,CXX,F,FC}FLAGS. Accepts shell globs.
79filter-flags() { 117filter-flags() {
80 for x in "$@" ; do 118 _filter-hardened "$@"
81 case "${x}" in 119 _filter-var CFLAGS "$@"
82 -fPIC|-fpic|-fPIE|-fpie) etexec-flags;; 120 _filter-var CPPFLAGS "$@"
83 -fstack-protector|-fstack-protector-all) fstack-flags;; 121 _filter-var CXXFLAGS "$@"
84 *) ;; 122 _filter-var FFLAGS "$@"
85 esac 123 _filter-var FCFLAGS "$@"
86 done 124 return 0
125}
87 126
88 # we do this fancy spacing stuff so as to not filter 127# @FUNCTION: filter-lfs-flags
89 # out part of a flag ... we want flag atoms ! :D 128# @DESCRIPTION:
90 CFLAGS=" ${CFLAGS} " 129# Remove flags that enable Large File Support.
130filter-lfs-flags() {
131 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments"
132 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
133}
134
135# @FUNCTION: append-cppflags
136# @USAGE: <flags>
137# @DESCRIPTION:
138# Add extra <flags> to the current CPPFLAGS.
139append-cppflags() {
140 [[ -z $* ]] && return 0
141 export CPPFLAGS="${CPPFLAGS} $*"
142 return 0
143}
144
145# @FUNCTION: append-cxxflags
146# @USAGE: <flags>
147# @DESCRIPTION:
148# Add extra <flags> to the current CXXFLAGS.
149append-cxxflags() {
150 [[ -z $* ]] && return 0
91 CXXFLAGS=" ${CXXFLAGS} " 151 export CXXFLAGS="${CXXFLAGS} $*"
92 for x in "$@" ; do
93 CFLAGS="${CFLAGS// ${x} / }"
94 CXXFLAGS="${CXXFLAGS// ${x} / }"
95 done
96 CFLAGS="${CFLAGS:1:${#CFLAGS}-2}"
97 CXXFLAGS="${CXXFLAGS:1:${#CXXFLAGS}-2}"
98 return 0 152 return 0
99} 153}
100 154
155# @FUNCTION: append-fflags
156# @USAGE: <flags>
157# @DESCRIPTION:
158# Add extra <flags> to the current {F,FC}FLAGS.
159append-fflags() {
160 [[ -z $* ]] && return 0
161 export FFLAGS="${FFLAGS} $*"
162 export FCFLAGS="${FCFLAGS} $*"
163 return 0
164}
165
166# @FUNCTION: append-lfs-flags
167# @DESCRIPTION:
168# Add flags that enable Large File Support.
169append-lfs-flags() {
170 [[ -n $@ ]] && die "append-lfs-flags takes no arguments"
171 append-cppflags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
172}
173
174# @FUNCTION: append-flags
175# @USAGE: <flags>
176# @DESCRIPTION:
177# Add extra <flags> to your current {C,CXX,F,FC}FLAGS.
101append-flags() { 178append-flags() {
179 [[ -z $* ]] && return 0
102 export CFLAGS="${CFLAGS} $@" 180 export CFLAGS="${CFLAGS} $*"
103 export CXXFLAGS="${CXXFLAGS} $@" 181 export CXXFLAGS="${CXXFLAGS} $*"
104 [ "`is-flag -fno-stack-protector`" -o "`is-flag -fno-stack-protector-all`" ] && fstack-flags 182 export FFLAGS="${FFLAGS} $*"
183 export FCFLAGS="${FCFLAGS} $*"
105 return 0 184 return 0
106} 185}
107 186
187# @FUNCTION: replace-flags
188# @USAGE: <old> <new>
189# @DESCRIPTION:
190# Replace the <old> flag with <new>. Accepts shell globs for <old>.
108replace-flags() { 191replace-flags() {
109 # we do this fancy spacing stuff so as to not filter 192 [[ $# != 2 ]] \
110 # out part of a flag ... we want flag atoms ! :D 193 && echo && eerror "Usage: replace-flags <old flag> <new flag>" \
111 CFLAGS=" ${CFLAGS} " 194 && die "replace-flags takes 2 arguments, not $#"
112 CXXFLAGS=" ${CXXFLAGS} "
113 CFLAGS="${CFLAGS// ${1} / ${2} }"
114 CXXFLAGS="${CXXFLAGS// ${1} / ${2} }"
115 CFLAGS="${CFLAGS:1:${#CFLAGS}-2}"
116 CXXFLAGS="${CXXFLAGS:1:${#CXXFLAGS}-2}"
117 return 0
118}
119 195
196 local f fset
197 declare -a new_CFLAGS new_CXXFLAGS new_FFLAGS new_FCFLAGS
198
199 for fset in CFLAGS CXXFLAGS FFLAGS FCFLAGS; do
200 # Looping over the flags instead of using a global
201 # substitution ensures that we're working with flag atoms.
202 # Otherwise globs like -O* have the potential to wipe out the
203 # list of flags.
204 for f in ${!fset}; do
205 # Note this should work with globs like -O*
206 [[ ${f} == ${1} ]] && f=${2}
207 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
208 done
209 eval export ${fset}=\${new_${fset}\[*]}
210 done
211
212 return 0
213}
214
215# @FUNCTION: replace-cpu-flags
216# @USAGE: <old> <new>
217# @DESCRIPTION:
218# Replace cpu flags (like -march/-mcpu/-mtune) that select the <old> cpu
219# with flags that select the <new> cpu. Accepts shell globs for <old>.
120replace-cpu-flags() { 220replace-cpu-flags() {
121 local newcpu="$1" ; shift 221 local newcpu="$#" ; newcpu="${!newcpu}"
122 local oldcpu="" 222 while [ $# -gt 1 ] ; do
123 for oldcpu in "$@" ; do 223 # quote to make sure that no globbing is done (particularly on
224 # ${oldcpu}) prior to calling replace-flags
124 replace-flags -march=${oldcpu} -march=${newcpu} 225 replace-flags "-march=${1}" "-march=${newcpu}"
125 replace-flags -mcpu=${oldcpu} -mcpu=${newcpu} 226 replace-flags "-mcpu=${1}" "-mcpu=${newcpu}"
227 replace-flags "-mtune=${1}" "-mtune=${newcpu}"
228 shift
126 done 229 done
230 return 0
231}
232
233_is_flagq() {
234 local x
235 for x in ${!1} ; do
236 [[ ${x} == $2 ]] && return 0
237 done
127 return 0 238 return 1
128} 239}
129 240
241# @FUNCTION: is-flagq
242# @USAGE: <flag>
243# @DESCRIPTION:
244# Returns shell true if <flag> is in {C,CXX,F,FC}FLAGS, else returns shell false. Accepts shell globs.
245is-flagq() {
246 [[ -n $2 ]] && die "Usage: is-flag <flag>"
247 _is_flagq CFLAGS $1 || _is_flagq CXXFLAGS $1 || _is_flagq FFLAGS $1 || _is_flagq FCFLAGS $1
248}
249
250# @FUNCTION: is-flag
251# @USAGE: <flag>
252# @DESCRIPTION:
253# Echo's "true" if flag is set in {C,CXX,F,FC}FLAGS. Accepts shell globs.
130is-flag() { 254is-flag() {
131 for x in ${CFLAGS} ${CXXFLAGS} ; do 255 is-flagq "$@" && echo true
132 if [ "${x}" == "$1" ] ; then
133 echo true
134 return 0
135 fi
136 done
137 return 1
138} 256}
139 257
258# @FUNCTION: is-ldflagq
259# @USAGE: <flag>
260# @DESCRIPTION:
261# Returns shell true if <flag> is in LDFLAGS, else returns shell false. Accepts shell globs.
262is-ldflagq() {
263 [[ -n $2 ]] && die "Usage: is-ldflag <flag>"
264 _is_flagq LDFLAGS $1
265}
266
267# @FUNCTION: is-ldflag
268# @USAGE: <flag>
269# @DESCRIPTION:
270# Echo's "true" if flag is set in LDFLAGS. Accepts shell globs.
271is-ldflag() {
272 is-ldflagq "$@" && echo true
273}
274
275# @FUNCTION: filter-mfpmath
276# @USAGE: <math types>
277# @DESCRIPTION:
278# Remove specified math types from the fpmath flag. For example, if the user
279# has -mfpmath=sse,386, running `filter-mfpmath sse` will leave the user with
280# -mfpmath=386.
140filter-mfpmath() { 281filter-mfpmath() {
282 local orig_mfpmath new_math prune_math
283
141 # save the original -mfpmath flag 284 # save the original -mfpmath flag
142 local orig_mfpmath="`get-flag -mfpmath`" 285 orig_mfpmath=$(get-flag -mfpmath)
143 # get the value of the current -mfpmath flag 286 # get the value of the current -mfpmath flag
144 local new_math=" `get-flag mfpmath | tr , ' '` " 287 new_math=$(get-flag mfpmath)
288 new_math=" ${new_math//,/ } "
145 # figure out which math values are to be removed 289 # figure out which math values are to be removed
146 local prune_math="" 290 prune_math=""
147 for prune_math in "$@" ; do 291 for prune_math in "$@" ; do
148 new_math="${new_math/ ${prune_math} / }" 292 new_math=${new_math/ ${prune_math} / }
149 done 293 done
150 new_math="`echo ${new_math:1:${#new_math}-2} | tr ' ' ,`" 294 new_math=$(echo ${new_math})
295 new_math=${new_math// /,}
151 296
152 if [ -z "${new_math}" ] ; then 297 if [[ -z ${new_math} ]] ; then
153 # if we're removing all user specified math values are 298 # if we're removing all user specified math values are
154 # slated for removal, then we just filter the flag 299 # slated for removal, then we just filter the flag
155 filter-flags ${orig_mfpmath} 300 filter-flags ${orig_mfpmath}
156 else 301 else
157 # if we only want to filter some of the user specified 302 # if we only want to filter some of the user specified
159 replace-flags ${orig_mfpmath} -mfpmath=${new_math} 304 replace-flags ${orig_mfpmath} -mfpmath=${new_math}
160 fi 305 fi
161 return 0 306 return 0
162} 307}
163 308
309# @FUNCTION: strip-flags
310# @DESCRIPTION:
311# Strip C[XX]FLAGS of everything except known good/safe flags.
164strip-flags() { 312strip-flags() {
313 local x y flag NEW_CFLAGS NEW_CXXFLAGS NEW_FFLAGS NEW_FCFLAGS
314
165 setup-allowed-flags 315 setup-allowed-flags
166 316
167 local NEW_CFLAGS="" 317 local NEW_CFLAGS=""
168 local NEW_CXXFLAGS="" 318 local NEW_CXXFLAGS=""
319 local NEW_FFLAGS=""
320 local NEW_FCFLAGS=""
169 321
170 # Allow unstable C[XX]FLAGS if we are using unstable profile ... 322 # Allow unstable C[XX]FLAGS if we are using unstable profile ...
171 if [ `has ~${ARCH} ${ACCEPT_KEYWORDS}` ] ; then 323 if has ~$(tc-arch) ${ACCEPT_KEYWORDS} ; then
172 [ `use debug` ] && einfo "Enabling the use of some unstable flags"
173 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}" 324 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}"
174 fi 325 fi
175 326
176 set -f 327 set -f # disable pathname expansion
177 328
178 for x in ${CFLAGS} 329 for x in ${CFLAGS}; do
179 do
180 for y in ${ALLOWED_FLAGS} 330 for y in ${ALLOWED_FLAGS}; do
181 do
182 flag=${x%%=*} 331 flag=${x%%=*}
183 if [ "${flag%%${y}}" = "" ] 332 if [ "${flag%%${y}}" = "" ] ; then
184 then
185 NEW_CFLAGS="${NEW_CFLAGS} ${x}" 333 NEW_CFLAGS="${NEW_CFLAGS} ${x}"
186 break 334 break
187 fi 335 fi
188 done 336 done
189 done 337 done
190 338
191 for x in ${CXXFLAGS} 339 for x in ${CXXFLAGS}; do
192 do
193 for y in ${ALLOWED_FLAGS} 340 for y in ${ALLOWED_FLAGS}; do
194 do
195 flag=${x%%=*} 341 flag=${x%%=*}
196 if [ "${flag%%${y}}" = "" ] 342 if [ "${flag%%${y}}" = "" ] ; then
197 then
198 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}" 343 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}"
199 break 344 break
200 fi 345 fi
201 done 346 done
202 done 347 done
203 348
349 for x in ${FFLAGS}; do
350 for y in ${ALLOWED_FLAGS}; do
351 flag=${x%%=*}
352 if [ "${flag%%${y}}" = "" ] ; then
353 NEW_FFLAGS="${NEW_FFLAGS} ${x}"
354 break
355 fi
356 done
357 done
358
359 for x in ${FCFLAGS}; do
360 for y in ${ALLOWED_FLAGS}; do
361 flag=${x%%=*}
362 if [ "${flag%%${y}}" = "" ] ; then
363 NEW_FCFLAGS="${NEW_FCFLAGS} ${x}"
364 break
365 fi
366 done
367 done
368
204 # In case we filtered out all optimization flags fallback to -O2 369 # In case we filtered out all optimization flags fallback to -O2
205 if [ "${CFLAGS/-O}" != "${CFLAGS}" -a "${NEW_CFLAGS/-O}" = "${NEW_CFLAGS}" ]; then 370 if [ "${CFLAGS/-O}" != "${CFLAGS}" -a "${NEW_CFLAGS/-O}" = "${NEW_CFLAGS}" ]; then
206 NEW_CFLAGS="${NEW_CFLAGS} -O2" 371 NEW_CFLAGS="${NEW_CFLAGS} -O2"
207 fi 372 fi
208 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then 373 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then
209 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2" 374 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2"
210 fi 375 fi
376 if [ "${FFLAGS/-O}" != "${FFLAGS}" -a "${NEW_FFLAGS/-O}" = "${NEW_FFLAGS}" ]; then
377 NEW_FFLAGS="${NEW_FFLAGS} -O2"
378 fi
379 if [ "${FCFLAGS/-O}" != "${FCFLAGS}" -a "${NEW_FCFLAGS/-O}" = "${NEW_FCFLAGS}" ]; then
380 NEW_FCFLAGS="${NEW_FCFLAGS} -O2"
381 fi
211 382
212 set +f 383 set +f # re-enable pathname expansion
213
214 [ `use debug` ] \
215 && einfo "CFLAGS=\"${NEW_CFLAGS}\"" \
216 && einfo "CXXFLAGS=\"${NEW_CXXFLAGS}\""
217 384
218 export CFLAGS="${NEW_CFLAGS}" 385 export CFLAGS="${NEW_CFLAGS}"
219 export CXXFLAGS="${NEW_CXXFLAGS}" 386 export CXXFLAGS="${NEW_CXXFLAGS}"
387 export FFLAGS="${NEW_FFLAGS}"
388 export FCFLAGS="${NEW_FCFLAGS}"
389 return 0
390}
391
392test-flag-PROG() {
393 local comp=$1
394 local flags="$2"
395
396 [[ -z ${comp} || -z ${flags} ]] && \
220 return 0 397 return 1
221}
222 398
399 local PROG=$(tc-get${comp})
400 ${PROG} ${flags} -S -o /dev/null -xc /dev/null \
401 > /dev/null 2>&1
402}
403
404# @FUNCTION: test-flag-CC
405# @USAGE: <flag>
406# @DESCRIPTION:
407# Returns shell true if <flag> is supported by the C compiler, else returns shell false.
408test-flag-CC() { test-flag-PROG "CC" "$1"; }
409
410# @FUNCTION: test-flag-CXX
411# @USAGE: <flag>
412# @DESCRIPTION:
413# Returns shell true if <flag> is supported by the C++ compiler, else returns shell false.
414test-flag-CXX() { test-flag-PROG "CXX" "$1"; }
415
416# @FUNCTION: test-flag-F77
417# @USAGE: <flag>
418# @DESCRIPTION:
419# Returns shell true if <flag> is supported by the Fortran 77 compiler, else returns shell false.
420test-flag-F77() { test-flag-PROG "F77" "$1"; }
421
422# @FUNCTION: test-flag-FC
423# @USAGE: <flag>
424# @DESCRIPTION:
425# Returns shell true if <flag> is supported by the Fortran 90 compiler, else returns shell false.
426test-flag-FC() { test-flag-PROG "FC" "$1"; }
427
428test-flags-PROG() {
429 local comp=$1
430 local flags
431 local x
432
433 shift
434
435 [[ -z ${comp} ]] && return 1
436
437 x=""
438 for x in "$@" ; do
439 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}"
440 done
441
442 echo "${flags}"
443
444 # Just bail if we dont have any flags
445 [[ -n ${flags} ]]
446}
447
448# @FUNCTION: test-flags-CC
449# @USAGE: <flags>
450# @DESCRIPTION:
451# Returns shell true if <flags> are supported by the C compiler, else returns shell false.
452test-flags-CC() { test-flags-PROG "CC" "$@"; }
453
454# @FUNCTION: test-flags-CXX
455# @USAGE: <flags>
456# @DESCRIPTION:
457# Returns shell true if <flags> are supported by the C++ compiler, else returns shell false.
458test-flags-CXX() { test-flags-PROG "CXX" "$@"; }
459
460# @FUNCTION: test-flags-F77
461# @USAGE: <flags>
462# @DESCRIPTION:
463# Returns shell true if <flags> are supported by the Fortran 77 compiler, else returns shell false.
464test-flags-F77() { test-flags-PROG "F77" "$@"; }
465
466# @FUNCTION: test-flags-FC
467# @USAGE: <flags>
468# @DESCRIPTION:
469# Returns shell true if <flags> are supported by the Fortran 90 compiler, else returns shell false.
470test-flags-FC() { test-flags-PROG "FC" "$@"; }
471
472# @FUNCTION: test-flags
473# @USAGE: <flags>
474# @DESCRIPTION:
475# Short-hand that should hopefully work for both C and C++ compiler, but
476# its really only present due to the append-flags() abomination.
477test-flags() { test-flags-CC "$@"; }
478
479# @FUNCTION: test_flag
480# @DESCRIPTION:
481# DEPRICIATED, use test-flags()
223test_flag() { 482test_flag() {
224 if gcc -S -xc "$@" -o /dev/null /dev/null >/dev/null 2>&1; then 483 ewarn "test_flag: deprecated, please use test-flags()!" >&2
225 echo "$@" 484
485 test-flags-CC "$@"
486}
487
488# @FUNCTION: test_version_info
489# @USAGE: <version>
490# @DESCRIPTION:
491# Returns shell true if the current C compiler version matches <version>, else returns shell false.
492# Accepts shell globs.
493test_version_info() {
494 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then
226 return 0 495 return 0
227 fi 496 else
228 return 1 497 return 1
498 fi
229} 499}
230 500
501# @FUNCTION: strip-unsupported-flags
502# @DESCRIPTION:
503# Strip {C,CXX,F,FC}FLAGS of any flags not supported by the active toolchain.
231strip-unsupported-flags() { 504strip-unsupported-flags() {
232 for x in ${CFLAGS} ; do 505 export CFLAGS=$(test-flags-CC ${CFLAGS})
233 NEW_CFLAGS=${NEW_CFLAGS}" ""`test_flag ${x}`" 506 export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS})
234 done 507 export FFLAGS=$(test-flags-F77 ${FFLAGS})
235 for x in ${CXXFLAGS} ; do 508 export FCFLAGS=$(test-flags-FC ${FCFLAGS})
236 NEW_CXXFLAGS=${NEW_CXXFLAGS}" ""`test_flag ${x}`"
237 done
238
239 export CFLAGS="${NEW_CFLAGS}"
240 export CXXFLAGS="${NEW_CXXFLAGS}"
241} 509}
242 510
511# @FUNCTION: get-flag
512# @USAGE: <flag>
513# @DESCRIPTION:
514# Find and echo the value for a particular flag. Accepts shell globs.
243get-flag() { 515get-flag() {
516 local f findflag="$1"
517
244 # this code looks a little flaky but seems to work for 518 # this code looks a little flaky but seems to work for
245 # everything we want ... 519 # everything we want ...
246 # for example, if CFLAGS="-march=i686": 520 # for example, if CFLAGS="-march=i686":
247 # `get-flags -march` == "-march=i686" 521 # `get-flag -march` == "-march=i686"
248 # `get-flags march` == "i686" 522 # `get-flag march` == "i686"
249 local findflag="$1"
250 for f in ${CFLAGS} ${CXXFLAGS} ; do 523 for f in ${CFLAGS} ${CXXFLAGS} ${FFLAGS} ${FCFLAGS} ; do
251 if [ "${f/${findflag}}" != "${f}" ] ; then 524 if [ "${f/${findflag}}" != "${f}" ] ; then
252 echo "${f/-${findflag}=}" 525 printf "%s\n" "${f/-${findflag}=}"
253 return 0 526 return 0
254 fi 527 fi
255 done 528 done
256 return 1 529 return 1
257} 530}
258 531
532# @FUNCTION: has_hardened
533# @DESCRIPTION:
534# DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs
535has_hardened() {
536 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2
537
538 test_version_info Hardened && return 0
539 # The specs file wont exist unless gcc has GCC_SPECS support
540 [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
541}
542
543# @FUNCTION: has_pic
544# @DESCRIPTION:
545# DEPRECATED - use gcc-specs-pie from toolchain-funcs
546# indicate whether PIC is set
547has_pic() {
548 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
549
550 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
551 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
552 gcc-specs-pie
553}
554
555# @FUNCTION: has_pie
556# @DESCRIPTION:
557# DEPRECATED - use gcc-specs-pie from toolchain-funcs
558# indicate whether PIE is set
559has_pie() {
560 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
561
562 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
563 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
564 gcc-specs-pie
565}
566
567# @FUNCTION: has_ssp_all
568# @DESCRIPTION:
569# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
570# indicate whether code for SSP is being generated for all functions
571has_ssp_all() {
572 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
573
574 # note; this matches only -fstack-protector-all
575 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
576 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
577 gcc-specs-ssp-to-all
578}
579
580# @FUNCTION: has_ssp
581# @DESCRIPTION:
582# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
583# indicate whether code for SSP is being generated
584has_ssp() {
585 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
586
587 # note; this matches both -fstack-protector and -fstack-protector-all
588 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
589 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
590 gcc-specs-ssp
591}
592
593# @FUNCTION: has_m64
594# @DESCRIPTION:
595# This doesn't test if the flag is accepted, it tests if the flag actually
596# WORKS. Non-multilib gcc will take both -m32 and -m64. If the flag works
597# return code is 0, else the return code is 1.
598has_m64() {
599 # this doesnt test if the flag is accepted, it tests if the flag
600 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
601 # please dont replace this function with test_flag in some future
602 # clean-up!
603
604 local temp="$(emktemp)"
605 echo "int main() { return(0); }" > "${temp}".c
606 MY_CC=$(tc-getCC)
607 ${MY_CC/ .*/} -m64 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
608 local ret=$?
609 rm -f "${temp}".c
610 [[ ${ret} != 1 ]] && return 0
611 return 1
612}
613
614# @FUNCTION: has_m32
615# @DESCRIPTION:
616# This doesn't test if the flag is accepted, it tests if the flag actually
617# WORKS. Non-mulilib gcc will take both -m32 and -64. If the flag works return
618# code is 0, else return code is 1.
619has_m32() {
620 # this doesnt test if the flag is accepted, it tests if the flag
621 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
622 # please dont replace this function with test_flag in some future
623 # clean-up!
624
625 [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0
626
627 local temp=$(emktemp)
628 echo "int main() { return(0); }" > "${temp}".c
629 MY_CC=$(tc-getCC)
630 ${MY_CC/ .*/} -m32 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
631 local ret=$?
632 rm -f "${temp}".c
633 [[ ${ret} != 1 ]] && return 0
634 return 1
635}
636
637# @FUNCTION: replace-sparc64-flags
638# @DESCRIPTION:
639# Sets mcpu to v8 and uses the original value as mtune if none specified.
259replace-sparc64-flags() { 640replace-sparc64-flags() {
260 local SPARC64_CPUS="ultrasparc v9" 641 local SPARC64_CPUS="ultrasparc3 ultrasparc v9"
261 642
262 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ] 643 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then
263 then
264 for x in ${SPARC64_CPUS} 644 for x in ${SPARC64_CPUS}; do
265 do
266 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}" 645 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}"
267 done 646 done
268 else 647 else
269 for x in ${SPARC64_CPUS} 648 for x in ${SPARC64_CPUS}; do
270 do
271 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 649 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
272 done 650 done
273 fi 651 fi
274 652
275 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ] 653 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then
276 then
277 for x in ${SPARC64_CPUS} 654 for x in ${SPARC64_CPUS}; do
278 do
279 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}" 655 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}"
280 done 656 done
281 else 657 else
282 for x in ${SPARC64_CPUS} 658 for x in ${SPARC64_CPUS}; do
283 do
284 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 659 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
285 done 660 done
286 fi 661 fi
287}
288 662
663 export CFLAGS CXXFLAGS
664}
665
666# @FUNCTION: append-ldflags
667# @USAGE: <flags>
668# @DESCRIPTION:
669# Add extra <flags> to the current LDFLAGS.
289append-ldflags() { 670append-ldflags() {
671 [[ -z $* ]] && return 0
672 local flag
673 for flag in "$@"; do
674 [[ ${flag} == -l* ]] && \
675 ewarn "Appending a library link instruction (${flag}); libraries to link to should not be passed through LDFLAGS"
676 done
677
290 LDFLAGS="${LDFLAGS} $@" 678 export LDFLAGS="${LDFLAGS} $*"
291 return 0 679 return 0
292} 680}
293 681
294etexec-flags() { 682# @FUNCTION: filter-ldflags
295 has_version sys-devel/hardened-gcc 683# @USAGE: <flags>
296 if [ $? == 0 ] ; then 684# @DESCRIPTION:
297 if [ "`is-flag -yet_exec`" != "true" ]; then 685# Remove particular <flags> from LDFLAGS. Accepts shell globs.
298 debug-print ">>> appending flags -yet_exec" 686filter-ldflags() {
299 append-flags -yet_exec 687 _filter-var LDFLAGS "$@"
300 append-ldflags -yet_exec 688 return 0
301 fi
302 fi
303} 689}
304 690
305fstack-flags() { 691# @FUNCTION: raw-ldflags
306 has_version sys-devel/hardened-gcc 692# @USAGE: <flags>
307 if [ $? == 0 ] ; then 693# @DESCRIPTION:
308 if [ "`is-flag -yno_propolice`" != "true" ]; then 694# Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
309 debug-print ">>> appending flags -yno_propolice" 695# are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
310 append-flags -yno_propolice 696# to gcc where it needs the '-Wl,'.
311 append-ldflags -yno_propolice 697raw-ldflags() {
312 fi 698 local x input="$@"
313 fi 699 [[ -z ${input} ]] && input=${LDFLAGS}
700 set --
701 for x in ${input} ; do
702 x=${x#-Wl,}
703 set -- "$@" ${x//,/ }
704 done
705 echo "$@"
314} 706}
707
708# @FUNCTION: bindnow-flags
709# @RETURN: Returns the flags to enable "now" binding in the current selected linker.
710# @DESCRIPTION:
711# DEPRECATED - Gets the flags needed for "NOW" binding
712bindnow-flags() {
713 ewarn "QA: stop using the bindnow-flags function ... simply drop it from your ebuild"
714}
715
716
717# Some tests for when we screw with things and want to make
718# sure we didn't break anything
719#TESTS() {
720# CFLAGS="-a -b -c=1"
721# CXXFLAGS="-x -y -z=2"
722# LDFLAGS="-l -m -n=3"
723#
724# die() { exit 1; }
725# (is-flag 1 2 3) && die
726# (is-ldflag 1 2 3) && die
727#
728# is-flagq -l && die
729# is-ldflagq -a && die
730# is-flagq -a || die
731# is-flagq -x || die
732# is-ldflagq -n=* || die
733# is-ldflagq -n && die
734#
735# strip-unsupported-flags
736# [[ ${CFLAGS} == "-c=1" ]] || die
737# [[ ${CXXFLAGS} == "-y -z=2" ]] || die
738#
739# echo "All tests pass"
740#}
741#TESTS

Legend:
Removed from v.1.37  
changed lines
  Added in v.1.133

  ViewVC Help
Powered by ViewVC 1.1.20